diff --git a/ldap/admin/src/scripts/schema-reload.pl.in b/ldap/admin/src/scripts/schema-reload.pl.in
index 8d235a6..3e8cc08 100644
--- a/ldap/admin/src/scripts/schema-reload.pl.in
+++ b/ldap/admin/src/scripts/schema-reload.pl.in
@@ -61,16 +61,13 @@ $schemadir = "";
 $verbose = 0;
 $host = "";
 $port = "";
-$first = "yes";
-$prefix = DSUtil::get_prefix();
 
 $ENV{'SHLIB_PATH'} = "$ENV{'LD_LIBRARY_PATH'}";
-$ENV{'PATH'} = "$prefix@ldaptool_bindir@:$prefix/usr/bin:@ldaptool_bindir@:/usr/bin";
+$ENV{'PATH'} = "@ldaptool_bindir@:/usr/bin:@ldaptool_bindir@:/usr/bin";
 
-DSUtil::libpath_add("$prefix@nss_libdir@");
-DSUtil::libpath_add("$prefix/usr/lib");
 DSUtil::libpath_add("@nss_libdir@");
 DSUtil::libpath_add("/usr/lib");
+DSUtil::libpath_add("/usr/lib64");
 
 $i = 0;
 while ($i <= $#ARGV) 
@@ -116,63 +113,9 @@ while ($i <= $#ARGV)
     }
     $i++;
 }
-
-
-opendir(DIR, "$prefix/etc/sysconfig");
-@files = readdir(DIR);
-foreach $file (@files){
-    if($file =~ /^dirsrv-/ && $file ne "dirsrv-admin"){
-        $instance_count++;
-        if($file =~ /dirsrv-(.*)/){
-            if($first eq "yes"){
-                $instances=$1;
-                $first = "no";
-            } else {
-                $instances=$instances . ", $1";
-            }
-            $name = $1;
-        }
-    }
-}
-    
-if($servid eq ""){
-    if ($instance_count == 1){
-        $servid = $name;
-    } else {
-        &usage;
-        print "You must supply a server instance identifier.  Use -Z to specify instance name\n";
-        print "Available instances: $instances\n";
-        exit (1);
-    }
-} elsif ($servid =~ /^dirsrv-/){
-    # strip off "dirsrv-"
-    $servid =~ s/^dirsrv-//;
-} elsif ($servid =~ /^slapd-/){
-    # strip off "slapd-"
-    $servid =~ s/^slapd-//;
-}
-@info = DSUtil::get_missing_info($prefix, $servid, $instances, $host, $port, $rootdn);
-
-if ($passwdfile ne ""){
-# Open file and get the password
-    unless (open (RPASS, $passwdfile)) {
-        die "Error, cannot open password file $passwdfile\n";
-    }
-    $passwd = <RPASS>;
-    chomp($passwd);
-    close(RPASS);
-} elsif ($passwd eq "-"){
-# Read the password from terminal
-	print "Bind Password: ";
-	# Disable console echo
-	system("@sttyexec@ -echo") if -t STDIN;
-	# read the answer
-	$passwd = <STDIN>;
-	# Enable console echo
-	system("@sttyexec@ echo") if -t STDIN;
-	print "\n";
-	chop($passwd); # trim trailing newline
-}
+$servid = DSUtil::get_server_id($servid, "@initconfigdir@");
+@info = DSUtil::get_missing_info("@instconfigdir@", $servid, $host, $port, $rootdn);
+$passwd = DSUtil::get_password_from_file($passwd, $passwdfile);
 
 if ( $info[2] eq "" || $passwd eq "" )
 { 
diff --git a/ldap/admin/src/scripts/start-slapd.in b/ldap/admin/src/scripts/start-slapd.in
index 6f1f6a5..d31ffcf 100755
--- a/ldap/admin/src/scripts/start-slapd.in
+++ b/ldap/admin/src/scripts/start-slapd.in
@@ -1,12 +1,18 @@
 #!/bin/sh
 
+source ./DSSharedLib
+
 # Script that starts the ns-slapd server.
 # Exit status can be:
 #       0: Server started successfully
 #       1: Server could not be started
 #       2: Server already running
 
-args=""
+usage ()
+{
+    echo "Usage: start-slapd [-Z serverID]"
+}
+
 while getopts "Z:SvVhi:d:w:" flag
 do
     case $flag in
@@ -17,66 +23,28 @@ do
         i) args=$args" -i $OPTARG";;
         w) args=$args" -w $OPTARG";;
         S) args=$args" -S";;
-        h) echo "Usage: start-slapd [-Z serverID]"
+        h) usage
            exit 0;;
-        ?) echo "Usage: start-slapd [-Z serverID]"
+        ?) usage
            exit 1;;
     esac
 done
 
-SCRIPT=$(readlink -f $0)
-SCRIPTPATH=$(dirname $SCRIPT)
-if [ $SCRIPTPATH == "/usr/sbin" ]
+servid=$(get_server_id "@initconfigdir@" $servid)
+if [ $? == 1 ]
 then
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/usr\/sbin//'`
-else
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/sbin//'`
+    usage
+    echo "You must supply a valid server instance identifier.  Use -Z to specify instance name"
+    echo "Available instances: $servid"
+    exit 1
 fi
 
-first="yes"
-if [ -z $servid ]
-then
-    # server id not provided, check if there is only one instance
-    inst_count=0
-    for i in `ls $prefix/etc/sysconfig/dirsrv-* 2>/dev/null`
-    do
-        if [ $i != '$prefix/etc/sysconfig/dirsrv-admin' ]
-        then
-            inst_count=`expr $inst_count + 1`
-            id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
-            if  [ $first == "yes" ]
-            then
-                instances=$id
-                first="no"
-            else
-                instances=$instances", $id"
-            fi
-            name=$id
-        fi
-    done 
-    if [ $inst_count -eq 1 ]
-    then
-        servid=$name
-    else 
-        # error
-        echo "Usage: start-slapd [-Z serverID]"
-        echo "You must supply a server instance identifier.  Use -Z to specify instance name"
-        echo "Available instances: $instances"
-        exit 1
-    fi
-elif [ $servid == slapd-* ]
-then
-    servid=`echo "$servid" | sed -e 's/slapd-//'`
-elif [ $servid == dirsrv-* ]
-then
-    servid=`echo "$servid" | sed -e 's/dirsrv-//'`
-fi
-
-@sbindir@/start-dirsrv -d $prefix/etc/sysconfig $servid $args
+@sbindir@/start-dirsrv -d @initconfigdir@ $servid $args
 if [ $? == 0 ]
 then
     echo Sucessfully started instance $servid
 else
     echo Failed to start instance $servid
 fi
+
 exit $?
diff --git a/ldap/admin/src/scripts/stop-slapd.in b/ldap/admin/src/scripts/stop-slapd.in
index 7661b17..c8b9f42 100755
--- a/ldap/admin/src/scripts/stop-slapd.in
+++ b/ldap/admin/src/scripts/stop-slapd.in
@@ -1,11 +1,18 @@
 #!/bin/sh
 
+source ./DSSharedLib
+
 # Script that stops the ns-slapd server.
 # Exit status can be:
 #       0: Server stopped successfully
 #       1: Server could not be stopped
 #       2: Server was not running
 
+usage ()
+{
+    echo "Usage: stop-slapd [-Z serverID]"
+}
+
 while getopts "Z:SvVhi:d:w:" flag
 do
     case $flag in
@@ -16,63 +23,23 @@ do
         i) args=$args" -i $OPTARG";;
         w) args=$args" -w $OPTARG";;
         S) args=$args" -S";;
-        h) echo "Usage: stop-slapd [-Z serverID]"
+        h) usage
            exit 0;;
-        ?) echo "Usage: stop-slapd [-Z serverID]"
+        ?) usage
            exit 1;;
     esac
 done
 
-SCRIPT=$(readlink -f $0)
-SCRIPTPATH=$(dirname $SCRIPT)
-if [ $SCRIPTPATH == "/usr/sbin" ]
+servid=$(get_server_id "@initconfigdir@" $servid)
+if [ $? == 1 ]
 then
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/usr\/sbin//'`
-else
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/sbin//'`
+    usage
+    echo "You must supply a valid server instance identifier.  Use -Z to specify instance name"
+    echo "Available instances: $servid"
+    exit 1
 fi
 
-first="yes"
-if [ -z $servid ]
-then
-    # server id not provided, check if there is only one instance
-    inst_count=0
-    for i in `ls $prefix/etc/sysconfig/dirsrv-* 2>/dev/null`
-    do
-        if [ $i != '$prefix/etc/sysconfig/dirsrv-admin' ]
-        then
-            inst_count=`expr $inst_count + 1`
-            id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
-            if  [ $first == "yes" ]
-            then
-                instances=$id
-                first="no"
-            else
-                instances=$instances", $id"
-            fi
-            name=$id
-        fi
-    done 
-    if [ $inst_count -eq 1 ]
-    then
-        servid=$name
-    else 
-        # error
-        echo "Usage: stop-slapd [-Z serverID]"
-        echo "You must supply a server instance identifier.  Use -Z to specify instance name"
-        echo "Available instances: $instances"
-        exit 1
-    fi
-elif [ $servid == slapd-* ]
-then
-    servid=`echo "$servid" | sed -e 's/slapd-//'`
-elif [ $servid == dirsrv-* ]
-then
-    servid=`echo "$servid" | sed -e 's/dirsrv-//'`
-fi
-
-
-@sbindir@/stop-dirsrv -d $prefix/etc/sysconfig $servid $args
+@sbindir@/stop-dirsrv -d @initconfigdir@ $servid $args
 if [ $? == 0 ]
 then
     echo Sucessfully stopped instance $servid
diff --git a/ldap/admin/src/scripts/suffix2instance.in b/ldap/admin/src/scripts/suffix2instance.in
index 0c31fc6..86b8905 100755
--- a/ldap/admin/src/scripts/suffix2instance.in
+++ b/ldap/admin/src/scripts/suffix2instance.in
@@ -1,104 +1,54 @@
 #!/bin/sh
 
-libpath_add() {
-    [ -z "$1" ] && return
-    LD_LIBRARY_PATH=${LD_LIBRARY_PATH:+$LD_LIBRARY_PATH:}$1
-}
-
-server_dir="@libdir@/dirsrv/"
-SCRIPT=$(readlink -f $0)
-SCRIPTPATH=$(dirname $SCRIPT)
-if [ $SCRIPTPATH == "/usr/sbin" ]
-then
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/usr\/sbin//'`
-    server_sbin="/usr/sbin"
-else
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/sbin//'`
-    server_sbin=$prefix"/sbin"
-fi
+source ./DSSharedLib
 
-libpath_add "$server_dir"
-libpath_add "$prefix@nss_libdir@"
-libpath_add "$prefix@libdir@"
+libpath_add "@libdir@/dirsrv/"
 libpath_add "@libdir@"
 libpath_add "@nss_libdir@"
-libpath_add "$prefix@pcre_libdir@"
+libpath_add "@pcre_libdir@"
 
 export LD_LIBRARY_PATH
 SHLIB_PATH=$LD_LIBRARY_PATH
 export SHLIB_PATH
 
-first="yes"
-args=""
+usage ()
+{
+    echo "Usage: suffix2index [-Z serverID] -s <suffix>"
+}
+
 while getopts "Z:s:h" flag
 do
     case $flag in
         Z) servid=$OPTARG;;
         s) args=$args" -s $OPTARG";;
-        h) echo "Usage: suffix2index [-Z serverID] -s <suffix>"
+        h) usage
            exit 0;;
-        ?) echo "Usage: suffix2index [-Z serverID] -s <suffix>"
+        ?) usage
            exit 1;;
     esac
 done
 
 if [ "$args" == "" ]
 then
-    echo "Usage: suffix2index [-Z serverID] -s <suffix>"
+    usage
     exit 1
 fi
 
-# server id not provided, check if there is only one instance
-inst_count=0
-for i in `ls $prefix/etc/sysconfig/dirsrv-* 2>/dev/null`
-do
-    if [ $i != '$prefix/etc/sysconfig/dirsrv-admin' ]
-    then
-        inst_count=`expr $inst_count + 1`
-        id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
-        if  [ $first == "yes" ]
-        then
-            instances=$id
-            first="no"
-        else
-            instances=$instances", $id"
-        fi
-        name=$id
-    fi
-done 
-    
-if [ -z $servid ]
-then
-    if [ $inst_count -eq 1 ]
-    then
-        servid=$name
-    else 
-        # error
-        echo "Usage: suffix2index [-Z serverID] -s <suffix>"
-        echo "You must supply a server instance identifier.  Use -Z to specify instance name"
-        echo "Available instances: $instances"
-        exit 1
-    fi
-elif [ $servid == slapd-* ]
-then
-    servid=`echo "$servid" | sed -e 's/slapd-//'`
-elif [ $servid == dirsrv-* ]
+servid=$(get_server_id "@initconfigdir@" $servid)
+if [ $? == 1 ]
 then
-    servid=`echo "$servid" | sed -e 's/dirsrv-//'`
-fi
-configdir="$prefix/etc/dirsrv/slapd-$servid"
-if ! [ -a $configdir ]
-then
-    echo "Invalid server identifier: $servid"
-    echo "Available instances: $instances"
+    usage
+    echo "You must supply a valid server instance identifier.  Use -Z to specify instance name"
+    echo "Available instances: $servid"
     exit 1
 fi
 
-cd $server_sbin
+configdir="@instconfigdir@/slapd-$servid"
+
 if [ $# -lt 2 ]
 then
 	echo Usage: suffix2instance [-Z serverID] {-s includesuffix}*
 	exit 1
 fi
 
-./ns-slapd suffix2instance -D $configdir $args 2>&1
+@sbindir@/ns-slapd suffix2instance -D $configdir $args 2>&1
diff --git a/ldap/admin/src/scripts/syntax-validate.pl.in b/ldap/admin/src/scripts/syntax-validate.pl.in
index 2d6c98b..18bddba 100644
--- a/ldap/admin/src/scripts/syntax-validate.pl.in
+++ b/ldap/admin/src/scripts/syntax-validate.pl.in
@@ -64,17 +64,14 @@ $passwdfile = "";
 $basedn_arg = "";
 $filter_arg = "";
 $filter = "";
-$first = "yes";
 $verbose = 0;
-$prefix = DSUtil::get_prefix();
 
 $ENV{'SHLIB_PATH'} = "$ENV{'LD_LIBRARY_PATH'}";
-$ENV{'PATH'} = "$prefix@ldaptool_bindir@:$prefix/usr/bin:@ldaptool_bindir@:/usr/bin";
+$ENV{'PATH'} = "@ldaptool_bindir@:/usr/bin:@ldaptool_bindir@:/usr/bin";
 
-DSUtil::libpath_add("$prefix@nss_libdir@");
-DSUtil::libpath_add("$prefix/usr/lib");
 DSUtil::libpath_add("@nss_libdir@");
 DSUtil::libpath_add("/usr/lib");
+DSUtil::libpath_add("/usr/lib64");
 
 $i = 0;
 while ($i <= $#ARGV) 
@@ -126,61 +123,9 @@ while ($i <= $#ARGV)
     $i++;
 }
 
-opendir(DIR, "$prefix/etc/sysconfig");
-@files = readdir(DIR);
-foreach $file (@files){
-    if($file =~ /^dirsrv-/ && $file ne "dirsrv-admin"){
-        $instance_count++;
-        if($file =~ /dirsrv-(.*)/){
-            if($first eq "yes"){
-                $instances=$1;
-                $first = "no";
-            } else {
-                $instances=$instances . ", $1";
-            }
-            $name = $1;
-        }
-    }
-}
-    
-if($servid eq ""){
-    if ($instance_count == 1){
-        $servid = $name;
-    } else {
-        &usage;
-        print "You must supply a server instance identifier.  Use -Z to specify instance name\n";
-        print "Available instances: $instances\n";
-        exit (1);
-    }
-} elsif ($servid =~ /^dirsrv-/){
-    # strip off "dirsrv-"
-    $servid =~ s/^dirsrv-//;
-} elsif ($servid =~ /^slapd-/){
-    # strip off "slapd-"
-    $servid =~ s/^slapd-//;
-}
-@info = DSUtil::get_missing_info($prefix, $servid, $instances, $host, $port, $rootdn);
-
-if ($passwdfile ne ""){
-# Open file and get the password
-    unless (open (RPASS, $passwdfile)) {
-        die "Error, cannot open password file $passwdfile\n";
-    }
-    $passwd = <RPASS>;
-    chomp($passwd);
-    close(RPASS);
-} elsif ($passwd eq "-"){
-# Read the password from terminal
-	print "Bind Password: ";
-	# Disable console echo
-	system("@sttyexec@ -echo") if -t STDIN;
-	# read the answer
-	$passwd = <STDIN>;
-	# Enable console echo
-	system("@sttyexec@ echo") if -t STDIN;
-	print "\n";
-	chop($passwd); # trim trailing newline
-}
+$servid = DSUtil::get_server_id($servid, "@initconfigdir@");
+@info = DSUtil::get_missing_info("@instconfigdir@", $servid, $host, $port, $rootdn);
+$passwd = DSUtil::get_password_from_file($passwd, $passwdfile);
 
 if ( $info[2] eq "" || $passwd eq "" || $basedn_arg eq "" ) 
 { 
@@ -201,7 +146,7 @@ $taskname = "syntax_validate_${yr}_${mn}_${dy}_${h}_${m}_${s}";
 
 # Build the task entry to add
 $dn = "dn: cn=$taskname, cn=syntax validate, cn=tasks, cn=config\n";
-$misc = "changetype: add\nobjectclass: top\nobjectclass: extensibleObject\n";
+$misc = "objectclass: top\nobjectclass: extensibleObject\n";
 $cn =  "cn: $taskname\n";
 $basedn = "basedn: $basedn_arg\n";
 
diff --git a/ldap/admin/src/scripts/upgradedb.in b/ldap/admin/src/scripts/upgradedb.in
index e250cc9..0f90567 100755
--- a/ldap/admin/src/scripts/upgradedb.in
+++ b/ldap/admin/src/scripts/upgradedb.in
@@ -1,35 +1,16 @@
 #!/bin/sh
 
-libpath_add() {
-    [ -z "$1" ] && return
-    LD_LIBRARY_PATH=${LD_LIBRARY_PATH:+$LD_LIBRARY_PATH:}$1
-}
+source ./DSSharedLib
 
-server_dir="@libdir@/dirsrv/"
-SCRIPT=$(readlink -f $0)
-SCRIPTPATH=$(dirname $SCRIPT)
-if [ $SCRIPTPATH == "/usr/sbin" ]
-then
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/usr\/sbin//'`
-    server_sbin="/usr/sbin"
-else
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/sbin//'`
-    server_sbin=$prefix"/sbin"
-fi
-
-libpath_add "$server_dir"
-libpath_add "$prefix@nss_libdir@"
-libpath_add "$prefix@libdir@"
+libpath_add "@libdir@/dirsrv/"
 libpath_add "@libdir@"
 libpath_add "@nss_libdir@"
-libpath_add "$prefix@pcre_libdir@"
+libpath_add "@pcre_libdir@"
 
 export LD_LIBRARY_PATH
 SHLIB_PATH=$LD_LIBRARY_PATH
 export SHLIB_PATH
 
-first="yes"
-args=""
 while getopts "Z:vfrd:" flag
 do
     case $flag in
@@ -43,58 +24,22 @@ do
     esac
 done
 
-# server id not provided, check if there is only one instance
-inst_count=0
-for i in `ls $prefix/etc/sysconfig/dirsrv-* 2>/dev/null`
-do
-    if [ $i != '$prefix/etc/sysconfig/dirsrv-admin' ]
-    then
-        inst_count=`expr $inst_count + 1`
-        id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
-        if  [ $first == "yes" ]
-        then
-            instances=$id
-            first="no"
-        else
-            instances=$instances", $id"
-        fi
-        name=$id
-    fi
-done 
-    
-if [ -z $servid ]
+servid=$(get_server_id "@initconfigdir@" $servid)
+if [ $? == 1 ]
 then
-    if [ $inst_count -eq 1 ]
-    then
-        servid=$name
-    else 
-        # error
-        echo "You must supply a server instance identifier.  Use -Z to specify instance name"
-        echo "Available instances: $instances"
-        exit 1
-    fi
-elif [ $servid == slapd-* ]
-then
-    servid=`echo "$servid" | sed -e 's/slapd-//'`
-elif [ $servid == dirsrv-* ]
-then
-    servid=`echo "$servid" | sed -e 's/dirsrv-//'`
-fi
-configdir="$prefix/etc/dirsrv/slapd-$servid"
-if ! [ -a $configdir ]
-then
-    echo "Invalid server identifier: $servid"
-    echo "Available instances: $instances"
+    echo "You must supply a valid server instance identifier.  Use -Z to specify instance name"
+    echo "Available instances: $servid"
     exit 1
 fi
 
-cd $server_sbin
+configdir="@instconfigdir@/slapd-$servid"
+
 if [ "$#" -eq 1 ]
 then
 	bak_dir=$1
 else
-	bak_dir=$prefix/var/lib/dirsrv/slapd-$servid/bak/upgradedb_`date +%Y_%m_%d_%H_%M_%S`
+	bak_dir=@localstatedir@/lib/@PACKAGE_NAME@/slapd-$servid/bak/upgradedb_`date +%Y_%m_%d_%H_%M_%S`
 fi
 
 echo upgrade index files ...
-./ns-slapd upgradedb -D $configdir -a $bak_dir $args
+@sbindir@/ns-slapd upgradedb -D $configdir -a $bak_dir $args
diff --git a/ldap/admin/src/scripts/upgradednformat.in b/ldap/admin/src/scripts/upgradednformat.in
index 6f6ded8..0e7304f 100755
--- a/ldap/admin/src/scripts/upgradednformat.in
+++ b/ldap/admin/src/scripts/upgradednformat.in
@@ -1,5 +1,7 @@
 #!/bin/sh
 
+source ./DSSharedLib
+
 # upgradednformat -- upgrade DN format to the new style (RFC 4514)
 # Usgae: upgradednformat [-N] -n backend_instance -a db_instance_directory
 #        -N: dryrun
@@ -8,42 +10,20 @@
 #        -a db_instance_directory -- full path to the db instance dir
 #                                    e.g., /var/lib/dirsrv/slapd-ID/db/userRoot
 
-libpath_add() {
-    [ -z "$1" ] && return
-    LD_LIBRARY_PATH=${LD_LIBRARY_PATH:+$LD_LIBRARY_PATH:}$1
-}
-
-server_dir="@libdir@/dirsrv/"
-SCRIPT=$(readlink -f $0)
-SCRIPTPATH=$(dirname $SCRIPT)
-if [ $SCRIPTPATH == "/usr/sbin" ]
-then
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/usr\/sbin//'`
-    server_sbin="/usr/sbin"
-else
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/sbin//'`
-    server_sbin=$prefix"/sbin"
-fi
-
-libpath_add "$server_dir"
-libpath_add "$prefix@nss_libdir@"
-libpath_add "$prefix@libdir@"
+libpath_add "@libdir@/dirsrv/"
+libpath_add "@nss_libdir@"
 libpath_add "@libdir@"
-libpath_add "$prefix@pcre_libdir@"
+libpath_add "@pcre_libdir@"
 
 export LD_LIBRARY_PATH
 SHLIB_PATH=$LD_LIBRARY_PATH
 export SHLIB_PATH
 
-cd $server_sbin
-
-dir=""
-be=""
-servid=""
-dryrun=0
-
-first="yes"
-args=""        
+usage ()
+{
+    echo "Usage: $0 [-N] [-Z serverID] -n backend_instance -a db_instance_directory"
+}
+ 
 while getopts "vhd:a:n:D:N" flag
 do
     case $flag in
@@ -55,67 +35,31 @@ do
            dir="set";;
         n) args=$args" -n $OPTARG"
            be="set";;
-        h) echo "Usage: $0 [-N] [-Z serverID] -n backend_instance -a db_instance_directory"
+        h) usage
            exit 0;;
         D) args=$args" -D $OPTARG";;
-        ?) echo "Usage: $0 [-N] [-Z serverID] -n backend_instance -a db_instance_directory"
+        ?) usage
            exit 1;;
     esac
 done
 
 if [ "$be" = "" ] || [ "$dir" = "" ]; then
-    echo "Usage: $0 [-N] [-Z serverID] -n backend_instance -a db_instance_directory"
+    usage
     exit 1
 fi
 
-
-    # server id not provided, check if there is only one instance
-    inst_count=0
-    for i in `ls $prefix/etc/sysconfig/dirsrv-* 2>/dev/null`
-    do
-        if [ $i != '$prefix/etc/sysconfig/dirsrv-admin' ]
-        then
-            inst_count=`expr $inst_count + 1`
-            id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
-            if  [ $first == "yes" ]
-            then
-                instances=$id
-                first="no"
-            else
-                instances=$instances", $id"
-            fi
-            name=$id
-        fi
-    done 
-    
-if [ -z $servid ]
-then
-    if [ $inst_count -eq 1 ]
-    then
-        servid=$name
-    else 
-        # error
-        echo "Usage: $0 [-N] [-Z serverID] -n backend_instance -a db_instance_directory"
-        echo "You must supply a server instance identifier.  Use -Z to specify instance name"
-        echo "Available instances: $instances"
-        exit 1
-    fi
-elif [ $servid == slapd-* ]
+servid=$(get_server_id "@initconfigdir@" $servid)
+if [ $? == 1 ]
 then
-    servid=`echo "$servid" | sed -e 's/slapd-//'`
-elif [ $servid == dirsrv-* ]
-then
-    servid=`echo "$servid" | sed -e 's/dirsrv-//'`
-fi
-configdir="$prefix/etc/dirsrv/slapd-$servid"
-if ! [ -a $configdir ]
-then
-    echo "Invalid server identifier: $servid"
-    echo "Available instances: $instances"
+    usage
+    echo "You must supply a valid server instance identifier.  Use -Z to specify instance name"
+    echo "Available instances: $servid"
     exit 1
 fi
 
-./ns-slapd upgradednformat -D $configdir $args
+configdir="@instconfigdir@/slapd-$servid"
 
+@sbindir@/ns-slapd upgradednformat -D $configdir $args
 rc=$?
+
 exit $rc
diff --git a/ldap/admin/src/scripts/usn-tombstone-cleanup.pl.in b/ldap/admin/src/scripts/usn-tombstone-cleanup.pl.in
index f03a53f..de4db8b 100644
--- a/ldap/admin/src/scripts/usn-tombstone-cleanup.pl.in
+++ b/ldap/admin/src/scripts/usn-tombstone-cleanup.pl.in
@@ -66,15 +66,12 @@ $maxusn_arg = "";
 $verbose = 0;
 $host = "";
 $port = "";
-$first = "yes";
-$prefix = DSUtil::get_prefix();
 
-$ENV{'PATH'} = "$prefix@ldaptool_bindir@:$prefix/usr/bin:@ldaptool_bindir@:/usr/bin";
+$ENV{'PATH'} = "@ldaptool_bindir@:/usr/bin:@ldaptool_bindir@:/usr/bin";
 
-DSUtil::libpath_add("$prefix@nss_libdir@");
-DSUtil::libpath_add("$prefix/usr/lib");
 DSUtil::libpath_add("@nss_libdir@");
 DSUtil::libpath_add("/usr/lib");
+DSUtil::libpath_add("/usr/lib64");
 
 $ENV{'SHLIB_PATH'} = "$ENV{'LD_LIBRARY_PATH'}";
 
@@ -133,62 +130,9 @@ while ($i <= $#ARGV)
     $i++;
 }
 
-
-opendir(DIR, "$prefix/etc/sysconfig");
-@files = readdir(DIR);
-foreach $file (@files){
-    if($file =~ /^dirsrv-/ && $file ne "dirsrv-admin"){
-        $instance_count++;
-        if($file =~ /dirsrv-(.*)/){
-            if($first eq "yes"){
-                $instances=$1;
-                $first = "no";
-            } else {
-                $instances=$instances . ", $1";
-            }
-            $name = $1;
-        }
-    }
-}
-    
-if($servid eq ""){
-    if ($instance_count == 1){
-        $servid = $name;
-    } else {
-        &usage;
-        print "You must supply a server instance identifier.  Use -Z to specify instance name\n";
-        print "Available instances: $instances\n";
-        exit (1);
-    }
-} elsif ($servid =~ /^dirsrv-/){
-    # strip off "dirsrv-"
-    $servid =~ s/^dirsrv-//;
-} elsif ($servid =~ /^slapd-/){
-    # strip off "slapd-"
-    $servid =~ s/^slapd-//;
-}
-@info = DSUtil::get_missing_info($prefix, $servid, $instances, $host, $port, $rootdn);
-
-if ($passwdfile ne ""){
-# Open file and get the password
-    unless (open (RPASS, $passwdfile)) {
-        die "Error, cannot open password file $passwdfile\n";
-    }
-    $passwd = <RPASS>;
-    chomp($passwd);
-    close(RPASS);
-} elsif ($passwd eq "-"){
-# Read the password from terminal
-	print "Bind Password: ";
-	# Disable console echo
-	system("@sttyexec@ -echo") if -t STDIN;
-	# read the answer
-	$passwd = <STDIN>;
-	# Enable console echo
-	system("@sttyexec@ echo") if -t STDIN;
-	print "\n";
-	chop($passwd); # trim trailing newline
-}
+$servid = DSUtil::get_server_id($servid, "@initconfigdir@");
+@info = DSUtil::get_missing_info("@instconfigdir@", $servid, $host, $port, $rootdn);
+$passwd = DSUtil::get_password_from_file($passwd, $passwdfile);
 
 if ( $info[2] eq "" || $passwd eq "" )
 { 
diff --git a/ldap/admin/src/scripts/verify-db.pl.in b/ldap/admin/src/scripts/verify-db.pl.in
index bff8a2e..364136c 100644
--- a/ldap/admin/src/scripts/verify-db.pl.in
+++ b/ldap/admin/src/scripts/verify-db.pl.in
@@ -149,7 +149,6 @@ if ($isWin) {
 
 my $i = 0;
 $startpoint = "";
-$prefix = DSUtil::get_prefix();
 
 while ($i <= $#ARGV) {
   if ( "$ARGV[$i]" eq "-a" ) {  # path to search the db files
@@ -164,39 +163,7 @@ while ($i <= $#ARGV) {
   $i++;
 }
 
-$first = "yes";
-if($servid eq ""){
-    opendir(DIR, "$prefix/etc/sysconfig");
-    @files = readdir(DIR);
-    foreach $file (@files){
-        if($file =~ /^dirsrv-/ && $file ne "dirsrv-admin"){
-            $instance_count++;
-            if($file =~ /dirsrv-(.*)/){
-                if($first eq "yes"){
-                    $instances=$1;
-                    $first = "no";
-                } else {
-                    $instances=$instances . ", $1";
-                }
-                $name = $1;
-            }
-        }
-    }
-    if ($instance_count == 1){
-        $servid = $name;
-    } else {
-        &usage;
-        print "You must supply a server instance identifier.  Use -Z to specify instance name\n";
-        print "Available instances: $instances\n";
-        exit (1);
-    }
-} elsif ($servid =~ /^dirsrv-/){
-    # strip off "dirsrv-"
-    $servid =~ s/^dirsrv-//;
-} elsif ($servid =~ /^slapd-/){
-    # strip off "slapd-"
-    $servid =~ s/^slapd-//;
-}
+$servid = DSUtil::get_server_id($servid, "@initconfigdir@");
 
 print("*****************************************************************\n");
 print("verify-db: This tool should only be run if recovery start fails\n" .
@@ -206,12 +173,12 @@ print("verify-db: This tool should only be run if recovery start fails\n" .
 print("*****************************************************************\n");
 
 if ( "$startpoint" eq "" ) {
-  $startpoint = "$prefix/var/lib/dirsrv/slapd-$servid/db";
+  $startpoint = "@localstatedir@/lib/@PACKAGE_NAME@/slapd-$servid/db";
 }
 # get dirs having DBVERSION
 my $dbdirs = getDbDir($startpoint);
 
-$ENV{'PATH'} = "@libdir@/dirsrv/slapd-$servid:$prefix@db_bindir@:$prefix/usr/bin:@db_bindir@:/usr/bin";
+$ENV{'PATH'} = "@libdir@/dirsrv/slapd-$servid:@db_bindir@:/usr/bin:@db_bindir@:/usr/bin";
 
 DSUtil::libpath_add("@db_libdir@");
 DSUtil::libpath_add("@libdir@");
diff --git a/ldap/admin/src/scripts/vlvindex.in b/ldap/admin/src/scripts/vlvindex.in
index 4f0c693..4854b00 100755
--- a/ldap/admin/src/scripts/vlvindex.in
+++ b/ldap/admin/src/scripts/vlvindex.in
@@ -1,35 +1,22 @@
 #!/bin/sh
 
-libpath_add() {
-    [ -z "$1" ] && return
-    LD_LIBRARY_PATH=${LD_LIBRARY_PATH:+$LD_LIBRARY_PATH:}$1
-}
-
-server_dir="@libdir@/dirsrv/"
-SCRIPT=$(readlink -f $0)
-SCRIPTPATH=$(dirname $SCRIPT)
-if [ $SCRIPTPATH == "/usr/sbin" ]
-then
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/usr\/sbin//'`
-    server_sbin="/usr/sbin"
-else
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/sbin//'`
-    server_sbin=$prefix"/sbin"
-fi
+source ./DSSharedLib
 
-libpath_add "$server_dir"
-libpath_add "$prefix@nss_libdir@"
-libpath_add "$prefix@libdir@"
+libpath_add "@libdir@/dirsrv/"
 libpath_add "@libdir@"
 libpath_add "@nss_libdir@"
-libpath_add "$prefix@pcre_libdir@"
+libpath_add "@pcre_libdir@"
 
 export LD_LIBRARY_PATH
 SHLIB_PATH=$LD_LIBRARY_PATH
 export SHLIB_PATH
 
-first="yes"
-args=""
+usage ()
+{
+    echo "Usage: vlvindex [-Z serverID] -n backend_instance | {-s includesuffix}* -T attribute"
+    echo Note: either \"-n backend_instance\" or \"-s includesuffix\" are required.
+}
+
 while getopts "Z:vd:a:t:T:Sn:s:x:hD:" flag
 do
     case $flag in
@@ -44,67 +31,28 @@ do
         n) args=$args" -n $OPTARG";;
         x) args=$args" -x $OPTARG";;
         D) args=$args" -D $OPTARG";;
-        h) echo "Usage: vlvindex [-Z serverID] -n backend_instance | {-s includesuffix}* -T attribute"
-           echo Note: either \"-n backend_instance\" or \"-s includesuffix\" are required.
+        h) usage
            exit 0;;
-        ?) echo "Usage: vlvindex [-Z serverID] -n backend_instance | {-s includesuffix}* -T attribute"
-           echo Note: either \"-n backend_instance\" or \"-s includesuffix\" are required.
+        ?) usage
            exit 1;;
     esac
 done
 
-# server id not provided, check if there is only one instance
-inst_count=0
-for i in `ls $prefix/etc/sysconfig/dirsrv-* 2>/dev/null`
-do
-    if [ $i != '$prefix/etc/sysconfig/dirsrv-admin' ]
-    then
-        inst_count=`expr $inst_count + 1`
-        id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
-        if  [ $first == "yes" ]
-        then
-            instances=$id
-            first="no"
-        else
-            instances=$instances", $id"
-        fi
-        name=$id
-    fi
-done
-     
-if [ -z $servid ]
-then
-    if [ $inst_count -eq 1 ]
-    then
-        servid=$name
-    else 
-        # error
-        echo "Usage: vlvindex [-Z serverID] -n backend_instance | {-s includesuffix}* -T attribute"
-        echo "You must supply a server instance identifier.  Use -Z to specify instance name"
-        echo "Available instances: $instances"
-        exit 1
-    fi
-elif [ $servid == slapd-* ]
-then
-    servid=`echo "$servid" | sed -e 's/slapd-//'`
-elif [ $servid == dirsrv-* ]
+servid=$(get_server_id "@initconfigdir@" $servid)
+if [ $? == 1 ]
 then
-    servid=`echo "$servid" | sed -e 's/dirsrv-//'`
-fi
-configdir="$prefix/etc/dirsrv/slapd-$servid"
-if ! [ -a $configdir ]
-then
-    echo "Invalid server identifier: $servid"
-    echo "Available instances: $instances"
+    usage
+    echo "You must supply a valid server instance identifier.  Use -Z to specify instance name"
+    echo "Available instances: $servid"
     exit 1
 fi
 
-cd $server_sbin
+configdir="@instconfigdir@/slapd-$servid"
+
 if [ $# -lt 4 ]
 then
-	echo "Usage: vlvindex [-Z serverID] -n backend_instance | {-s includesuffix}* -T attribute"
-	echo Note: either \"-n backend_instance\" or \"-s includesuffix\" are required.
+	usage
 	exit 1
 fi
 
-./ns-slapd db2index -D $configdir $args
+@sbindir@/ns-slapd db2index -D $configdir $args
-- 
1.7.1

